/**
 * Kivu4j. Copyright (C) 2010 . see<http://kivu4j.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */


package net.sourceforge.kivu4j.job.domain;

import net.sourceforge.kivu4j.utils.lang.domain.Persistent;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.springframework.beans.BeanUtils;


/**
 * 任务时间表
 *
 * @author Lucky Yang
 */
public class Timetable extends Persistent<Long> {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3186935209202342738L;
	private String clazz;
	private String description;
	private String cronExpression;
	private String data;
	private Boolean isActive;
	
	public Timetable() {
		super();
	}
	
	/**
	 * constructure. isActive property set to true.
	 *
	 * @param name
	 * @param group
	 * @param cronExpression
	 */
	public Timetable(String clazz, String cronExpression) {
		super();
		this.clazz = clazz;
		this.cronExpression = cronExpression;
		this.isActive = true;
	}

	public String getClazz() {
		return clazz;
	}
	public void setClazz(String clazz) {
		this.clazz = clazz;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getData() {
		return data;
	}
	public void setData(String data) {
		this.data = data;
	}
	public String getCronExpression() {
		return cronExpression;
	}
	public void setCronExpression(String cronExpression) {
		this.cronExpression = cronExpression;
	}
	public Boolean getIsActive() {
		return isActive;
	}
	public boolean isActive() {
		return isActive == true;
	}	
	public void setIsActive(Boolean isActive) {
		this.isActive = isActive;
	}
	
	@Override
	public String toString() {
		return new ToStringBuilder(this)
			.append(super.toString())
			.append("clazz", this.getClazz())
			.append("data", this.getData())
			.append("cronExpression", this.getCronExpression())
			.append("isActive", this.isActive)
			.toString();
	}
	
	@Override
	public void copyProperties(Object source) {
		BeanUtils.copyProperties(source, this, new String[] {
				"id", "createOn", "modifyOn"});
		
	}		
}
